



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>异步 Apex 类</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">异步 Apex 类</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 15:24:07 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>异步Apex类</h1>
<p>一个Apex类可以定义为异步类，用于异步执行。</p>
<p>异步类可以通过多种方式实现：</p>
<ul><li>Future注解</li>
<li>批处理</li>
<li>Queueable接口</li>
<li>Schedulable接口</li></ul>
<h1>Future注解</h1>
<p>使用Future注解可以将一个Apex函数定义为异步执行类。该类会拥有自己的线程，并在此线程中独立运行，实现异步效果。</p>
<p>Future注解的应用示例：</p>
<pre class="prettyprint linenums"><code>global class ExampleClass {<br />
    @future<br />
    public static void exampleFutureFunction(List&lt;Id&gt; recordIds) {<br />
        // ..<br />
    }<br />
}<br />
</code></pre>
<p>要注意的是，在Future函数中不可以用sObject对象作为参数，因为Future函数是独立运行的，如果将sObject对象传入其中，该sObject对象在Future函数运行的同时有可能被改变，这样有可能会造成错误。</p>
<p>定义为Future的函数必须是静态的（static），并且返回类型必须是void。</p>
<p>由于异步函数的特点，在多个Future函数同时执行的时候，执行的顺序是不确定的，完成的顺序也不确定。所以作为开发者，我们不能设想用一个Future函数的执行结果来影响另一个Future函数，也不能从Future函数中调用另一个Future函数。</p>
<h2>在Apex函数中调用外部网络服务</h2>
<p>在Apex函数中调用外部网络服务时，可以定义该函数为Future，并加入“callout=true”。比如：</p>
<pre class="prettyprint linenums"><code>@future(callout=true)<br />
public static void callWebService() {<br />
    String result = ExampleWebServiceClass.getWebServiceResult();<br />
}<br />
</code></pre>
<p>通过这种方式，此函数不需要等待网络服务的回应，从而可以继续执行其他的功能。</p>
<h2>Future函数单元测试</h2>
<p>在对Future函数进行单元测试时，必须将测试的代码放入“startTest()”和“stopTest()”函数中间。“stopTest()”函数可以确保在异步执行的函数得到结果之后再继续执行后面的代码。比如：</p>
<pre class="prettyprint linenums"><code>@isTest<br />
static void testExampleFutureFunction() {<br />
    // ...

    Test.startTest();

    ExampleClass.exampleFutureFunction();

    Test.stopTest();

    // ...<br />
}<br />
</code></pre>
<h2>最佳实践</h2>
<p>由于Salesforce将所有异步函数保存在一个队列中执行，所以如果同时运行的Future函数过多，会导致异步执行的效率降低。</p>
<p>使用Future函数时，尽量保证该函数被尽快执行。</p>
<p>如果需要同时调用若干外部网络服务请求，尽量将这些请求放在一个Future函数中，而不要对每一个请求建立单独的Future函数。</p>
<h1>批处理Apex</h1>
<p>当开发者想在代码中处理大批量的数据时，很容易会使数据库查询的次数达到上限。为了避免这种情况，Apex提供了“Database.Batchable”接口，可以让开发者实现批处理Apex类，用于异步执行大批量数据的查询操作。</p>
<p>“Database.Batchable”接口包含了如下函数：</p>
<ul><li>start()：初始化函数，对要处理的数据进行初始化，并将要处理的数据作为返回值，分批传入execute()函数。返回的类型可以是“Database.QueryLocator”或“Iterable”</li>
<li>execute()：从start()函数中分批接收数据，并对每批数据进行处理。数据被处理的顺序并不一定和从start()函数传入的顺序一致</li>
<li>finish()：当execute()函数执行完成后，对数据进行最后的处理</li></ul>
<p>一个标准的批处理类的结构：</p>
<pre class="prettyprint linenums"><code>global class ExampleBatchClass implements Database.Batchable&lt;sObject&gt; {

    global (Database.QueryLocator | Iterable&lt;sObject&gt;) start(Database.BatchableContext bc) {<br />
        // 得到需要处理的数据<br />
    }

    global void execute(Database.BatchableContext bc, List&lt;P&gt; records){<br />
        // 处理数据<br />
    }    

    global void finish(Database.BatchableContext bc){<br />
        // 收尾函数<br />
    }    

}<br />
</code></pre>
<h2>执行批处理Apex类</h2>
<p>使用“Database.executeBatch()”函数可以执行一个批处理Apex类。与此同时，还可以设定一个参数，指定从start()函数传入execute()函数的每批记录的最大数量（如果不设置则为200）。每次执行的时候，会返回一个ID类型的结果，通过这个ID可以在Salesforce中的AsyncApexJob对象中查询当前批处理的执行情况。</p>
<p>示例代码：</p>
<pre class="prettyprint linenums"><code>// 执行批处理类<br />
ExampleBatchClass exampleBatchClass = new ExampleBatchClass();

// 不设定每批记录的最大数量并执行批处理操作<br />
Id batchId = Database.executeBatch(exampleBatchClass);

// 不设定每批记录的最大数量并执行批处理操作<br />
Id batchIdWithVolumn = Database.executeBatch(exampleBatchClass, 300);

// 查询批处理任务的进度<br />
AsyncApexJob job = [SELECT<br />
                    Id, Status, JobItemsProcessed, TotalJobItems, NumberOfErrors<br />
                    FROM AsyncApexJob<br />
                    WHERE ID = :batchId];<br />
</code></pre>
<h2>在批处理Apex类中记录数据的状态</h2>
<p>通过实现“Database.Stateful”接口可以在批处理类中记录数据被处理的状态，并可以在类中设定非静态变量，该变量的值在处理每批数据时不会自动刷新。</p>
<p>示例代码：</p>
<pre class="prettyprint linenums"><code>global class ExampleBatchClass implements Database.Batchable&lt;sObject&gt;, Database.Stateful {

    // 定义一个非静态变量，记录execute执行的次数<br />
    global Integer executeProcessed = 0;

    global (Database.QueryLocator | Iterable&lt;sObject&gt;) start(Database.BatchableContext bc) {<br />
    }

    global void execute(Database.BatchableContext bc, List&lt;P&gt; records){<br />
        // 每次执行execute()函数，便增加1<br />
        executeProcessed += 1;<br />
    }    

    global void finish(Database.BatchableContext bc){<br />
        // 在此可以显示总共执行了多少次execute()函数<br />
        System.debug(executeProcessed);<br />
    }    

}<br />
</code></pre>
<h2>批处理Apex类的单元测试</h2>
<p>对批处理Apex类进行单元测试时，与Future函数类似，执行代码要包含在“Test.startTest()”和“Test.stopTest()”函数中。并且，在单元测试中，只能处理一个批次的记录，所以在定义测试数据时，不要让测试数据总数超过200条。</p>
<h1>Queueable接口</h1>
<p>Queueable接口的作用和Future函数类似，但是实现了Queueable的类可以使用sObject对象作为参数进行操作，这一点Future函数做不到。</p>
<p>Queueable接口中定义了“execute()”函数。它必须是global或者public的。</p>
<p>“System.enqueueJob()”函数可以将实现了Queueable接口的类加入系统的队列，异步执行。</p>
<p>代码结构如下：</p>
<pre class="prettyprint linenums"><code>public class ExampleClass implements Queueable {<br />
    public void execute(QueueableContext context) {<br />
        // ...<br />
    }<br />
}<br />
</code></pre>
<p>示例代码：</p>
<p>首先定义一个Apex类，实现Queueable接口。该类的功能是对于每一个Account对象，设置parentId字段并更新：</p>
<pre class="prettyprint linenums"><code>public class UpdateParentAccount implements Queueable {

    private List&lt;Account&gt; accounts;<br />
    private ID parent;

    public UpdateParentAccount(List&lt;Account&gt; records, ID id) {<br />
        this.accounts = records;<br />
        this.parent = id;<br />
    }

    public void execute(QueueableContext context) {<br />
        for (Account account : accounts) {<br />
          account.parentId = parent;<br />
        }<br />
        update accounts;<br />
    }

}<br />
</code></pre>
<p>然后在代码中调用此类，实现异步操作。假设已经有了一个Account列表和一个ID值：</p>
<pre class="prettyprint linenums"><code>// 设定参数<br />
UpdateParentAccount updateJob = new UpdateParentAccount(accountList, parentId);

// 执行该操作<br />
ID jobID = System.enqueueJob(updateJob);<br />
</code></pre>
<p>通过此代码，即可实现异步将accountList列表中的Account对象的parentId字段更新为参数parentId的值。</p>
<h2>实现Queueable的类的单元测试</h2>
<p>对实现了Queueable的Apex类进行单元测试时，与Future函数类似，执行代码要包含在“Test.startTest()”和“Test.stopTest()”函数中。比如：</p>
<pre class="prettyprint linenums"><code>UpdateParentAccount updateJob = new UpdateParentAccount(accountList, parentId);

Test.startTest();<br />
// 执行操作的代码要放在startTest()和stopTest()之间<br />
ID jobID = System.enqueueJob(updateJob);<br />
Test.stopTest();<br />
</code></pre>
<h2>任务的连续处理</h2>
<p>Queueable接口的另一个优点是可以在execute()函数中调用另一个实现了Queueable的类，实现任务的连续处理。比如：</p>
<pre class="prettyprint linenums"><code>public class FirstJob implements Queueable {<br />
    public void execute(QueueableContext context) {<br />
        // 连接下一个任务<br />
        System.enqueueJob(new SecondJob());<br />
    }<br />
}<br />
</code></pre>
<p>任务的连续处理最多可以同时处理50个任务，并且在连接任务时，每个execute()函数中只能连接一个任务。</p>
<h1>Schedulable接口</h1>
<p>当一个类实现了Schedulable接口之后，可以被作为计划任务，在特定的时间执行。</p>
<p>Schedulable接口中定义了“execute()”函数。它必须是global或者public的。</p>
<p>代码结构如下：</p>
<pre class="prettyprint linenums"><code>global class SchedulableExampleClass implements Schedulable {<br />
    global void execute(SchedulableContext ctx) {<br />
        // ...<br />
    }<br />
}<br />
</code></pre>
<p>“System.Schedule()”或“System.scheduleBatch()”函数可以设置实现了Schedulable的类在某个特定时间执行。调用Schedulable类和调用Queueable类的方式类似：</p>
<p>示例代码：定义Apex类的计划执行</p>
<pre class="prettyprint linenums"><code>String CRON_EXP = '0 0 06 * * ?';<br />
String jobId = System.schedule('Scheduled Job Name', CRON_EXP, new SchedulableExampleClass());<br />
</code></pre>
<p>在上述代码中，使用了System.schedule()函数。它包含三个参数：</p>
<ul><li>第一个参数是计划任务的名字，可以自己定义，不能与已经存在的计划任务名字重复</li>
<li>第二个参数是cron job的表达式，具体可以参考<a href="https://zh.wikipedia.org/wiki/Cron" rel="external nofollow noreferrer">维基百科</a>或<a href="https://crontab.guru/" rel="external nofollow noreferrer">crontab</a>。一个基本的解释：表达式包含7个部分，从左到右依次是：秒、分钟、小时、日、月、星期几、年，其中后两个是可选项。“*”表示所有可能的值，比如对于“小时”就是包括了0点到23点。“？”表示任一可能的值，比如对于“星期几”就是每周任意一天。</li>
<li>第三个参数是要被计划的实现了Schedulable接口的类</li></ul>
<h3>关于cron job的表达式</h3>
<p>其格式为：</p>
<pre class="prettyprint linenums"><code>Seconds Minutes Hours Day_of_month Month Day_of_week Optional_year<br />
</code></pre>
<p>可以用问号（?）来表示“每一个”。比如上面代码中的“0 0 06 * * ?”就代表了每天6点。“0 0 10 ? * MON-FRI”就代表了周一到周五早上10点。</p>
<h2>Apex类计划执行的特点</h2>
<ul><li>所有计划都要定义一个执行的时间点，比如早上8点。如果在同一时间有多个Apex类被设定为计划执行，则它们其中的一部分的执行有可能有延迟</li>
<li>Salesforce中可以定义计划执行的Apex类最多是100个</li></ul>
<h2>用CronTrigger追踪计划任务</h2>
<p>System.schedule()函数返回的值是ID类型，代表了当前计划任务的ID。使用CronTrigger对象可以追踪此任务的情况。</p>
<p>在知道计划任务ID的时候，可以使用以下查询语句：</p>
<pre class="prettyprint linenums"><code>CronTrigger ct = [SELECT TimesTriggered, NextFireTime FROM CronTrigger WHERE Id = :jobId];<br />
</code></pre>
<p>如果在实现了Schedulable接口的Apex类中，在execute()函数里需要查询当前计划任务的ID，可以使用SchedulableContext的getTriggerId()函数。</p>
<pre class="prettyprint linenums"><code>CronTrigger ct = [SELECT TimesTriggered, NextFireTime FROM CronTrigger WHERE Id = :sc.getTriggerId()];<br />
</code></pre>
<p>关于SchedulableContext的详细信息可以参考<a href="https://developer.salesforce.com/docs/atlas.en-us.apexcode.meta/apexcode/apex_interface_system_schedulablecontext.htm" rel="external nofollow noreferrer">官方文档</a>。</p>
<h2>用CronJobDetail得到计划任务的详细信息</h2>
<p>CronJobDetail对象和CronTrigger对象相关联。可以使用如下查询得到计划任务的详细信息：</p>
<pre class="prettyprint linenums"><code>CronTrigger job = [SELECT Id, CronJobDetail.Id, CronJobDetail.Name, CronJobDetail.JobType<br />
                    FROM CronTrigger<br />
                    ORDER BY CreatedDate DESC<br />
                    LIMIT 10];<br />
</code></pre>
<p>注意这里的CronJobDetail.JobType字段，此字段代表了所有任务的类型，对于Apex计划任务，此字段的值为7。</p>
<p>比如：</p>
<pre class="prettyprint linenums"><code>SELECT COUNT() FROM CronTrigger WHERE CronJobDetail.JobType = '7'<br />
</code></pre>
<h2>单元测试Apex计划任务</h2>
<p>对实现了Schedulable的Apex类进行单元测试时，与Future函数类似，执行代码要包含在“Test.startTest()”和“Test.stopTest()”函数中。比如：</p>
<pre class="prettyprint linenums"><code>// 定义计划任务类<br />
global class SchedulableExampleClass implements Schedulable {<br />
    global void execute(SchedulableContext sc) {<br />
        Account a = [SELECT Id, Name FROM Account WHERE Name = 'TEST ACCOUNT'];<br />
        a.Name = 'CHANGED NAME';

        update a;<br />
    }<br />
}

// 单元测试类<br />
@isTest<br />
class TestScheduleExample {<br />
    @isTest<br />
    static void testExample() {

        // 开始测试<br />
        Test.startTest();

        // 建立测试数据<br />
        Account a = new Account();<br />
        a.Name = 'TEST ACCOUNT';<br />
        insert a;

        // 建立计划任务的执行<br />
        String jobId = System.schedule('Scheduled Job', '0 0 0 3 9 ? 2022', new SchedulableExampleClass());

        // 得到计划任务的信息<br />
        CronTrigger ct = [SELECT Id, CronExpression, TimesTriggered, NextFireTime<br />
                            FROM CronTrigger<br />
                            WHERE Id = :jobId];

        // 检查计划任务的Cron表达式是否相同<br />
        System.assertEquals('0 0 0 3 9 ? 2022', ct.CronExpression);

        // 检查计划任务是否尚未运行<br />
        System.assertEquals(0, ct.TimesTriggered);

        // 检查计划任务下次运行时间<br />
        System.assertEquals('2022-09-03 00:00:00', String.valueOf(ct.NextFireTime));

        // 检查数据是否尚未改变<br />
        System.assertNotEquals('CHANGED NAME', [SELECT Id, Name FROM Account WHERE Id = :a.Id].Name);

        // 完成测试<br />
        Test.stopTest();<br />
        // 在stopTest()执行之后，已经计划的任务会忽略Cron表达式定义的时间立即执行，并且是同步执行，所以可以保证在执行接下来的语句之前，计划的Apex类的功能已经完成了

        // 检查数据是否改变了<br />
        System.assertEquals('CHANGED NAME', [SELECT Id, Name FROM Account WHERE Id = :a.Id].Name);<br />
    }<br />
}<br />
</code></pre>
<h2>通过设置界面设置Apex类计划执行</h2>
<p>在“设置”界面中，搜索“Apex 类”，可以进入“Apex 类”界面。在此界面中列出了所有系统中存在的Apex类。点击“计划Apex”按钮，即可计划一个实现了Schedulable接口的Apex类，以每周或每月为间隔自动执行。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8k1x359.html">github怎么退出组织和删除自己创建的组织</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9je2nw8.html">BZOJ1264&mdash;&mdash;&lbrack;AHOI2006&rsqb;基因匹配Match</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q235no9.html">Linux 任务计划</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8err0kq.html">SignalR入门之持久性连接</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mxl109.html">jquery简单入门（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96gelv8.html">tomcat的下载安装和配置以及和eclipse的配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/96oj2g49.html">class打包成exe方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn12z5k8.html">Head First设计模式-单例模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydx5xmq.html">js正则表达式及代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mep206q.html">Oracle11G卸载教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjy4pg8.html">Android网络下载图片</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jg31v8.html">轻谈 return i&plus;&plus;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkxdjz8.html">Codefoces 723A The New Year&colon; Meeting Friends</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pnk648.html">Xcode的playground中对于SpriteKit物理对象的更新为何无效</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ye5m08.html">python基础-小练习</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o11yg5q.html">Not posting notification with icon&equals;&equals;0问题解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjvwv79.html">java使用代理发post请求</a>
		</li>
						<li><a href="https://www.batexi.com/a/q256pzxq.html">HDU 2865 Birthday Toy</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkgnrn8.html">《Deep Learning》&lpar;深度学习&rpar;中文版PDF免费下载</a>
		</li>
						<li><a href="https://www.batexi.com/a/953mmde8.html">代码静态检查Eclipse插件：SonarLint插件离线安装</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qxdzvmv9.html">HTML和CSS使用注意事项</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnv4p1g8.html">markdown上下左右，跳至行尾行首，重设快捷键</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyy0mwjq.html">MySQL 线程池&amp;amp&semi;连接池&amp;amp&semi;长连接&amp;amp&semi;短连接</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjr27z9.html">vue 自学笔记&lpar;1&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7ojm2x8.html">Spring Boot - 修改Tomcat默认的8080端口</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxd4k5d9.html">Netty心跳机制</a>
			</li>
						<li><a href="https://www.batexi.com/a/q256jzwq.html">（转）深度学习目标检测指标mAP</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1211eq.html">120分钟React快速扫盲教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/93w6wg0q.html">获取多个checkbox的选中值</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv27dny9.html">数据分析之pandas模块</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
